.text
	.align 4
.globl page_fault_handler_wrapper
	.type	 page_fault_handler_wrapper,@function
page_fault_handler_wrapper:
	# This is the interrupt handler for the C page_fault_handler function.
	# This code should only be called by the interrupt handler !!! (else will seg fault cos iret)
	
	pusha			# save registers (nearly all of the general purpose ones) on the stack
	movl 48(%esp),%eax	# get the value of the esp of the process that was interrupted
	pushl	%ds
	pushl	%es
	pushl	%fs
	pushl	%gs

   	# set the segment regs
	movl	$0x18, %eax
   	movl	%eax, %ds
	movl	%eax, %es		
	movl	%eax, %fs
	movl	%eax, %gs
      
	# save cr0
	movl	%cr0, %eax
	pushl	 %eax
	
	pushl   %eax		
	movl    %cr2, %eax
	pushl   %eax		# memory that caused the page fault.
   	call    page_fault_handler	# call the C page_fault_handler
	addl	$8, %esp

	# Put back cr0
	popl	%eax
	movl	%eax, %cr0
	
	popl	%gs
	popl	%fs
	popl	%es
	popl	%ds
	popa			# restore the registers
	addl	$4, %esp
	iret			# return from interrupt handler
