#   Spinlock
#   Simple acquire and release functions.
#   Parameter: pointer to lock
#   Returns once lock is aquired or been released.
#   We do not test on release if it's been tampered or not.
	
.text
	.align 4
.globl get_spinlock
.globl put_spinlock
	.type	 get_spinlock@function
	.type    put_spinlock@function
.globl asm_XCHG
	.type	asm_XCHG@function
get_spinlock:
	# save registers
	push	%ebp
	movl	%esp, %ebp
	push	%esi	
	push	%edi
	# get parameter (lock)
	movl	8(%ebp), %esi
	xor	%edi, %edi
	push	$0		# push 0 as parameter for future yields
spin:	
	xchg	(%esi), %edi	# try to get the 1 from the lock (and insert a 0)
	test	%edi, %edi	# if we get back a zero
	jne	get_done	# then we need to loop
	call	sys_yield	# until we get a 1
	jmp	spin
get_done:
	pop	%eax		# pop the zero
	pop	%edi
	pop	%esi
	movl	%ebp, %esp
	pop	%ebp
	ret

put_spinlock:
	# To release we must use the xchg again, cos we don't want to
	# mix different types of addressing
	movl	4(%esp), %ecx
	movl	$1, %eax
	xchg    (%ecx), %eax	# put back the 1 in the lock
	ret

   
asm_XCHG:
	movl	4(%esp), %ecx	# this is just a test lock.
	movl	8(%esp), %eax	# there is no spining if we get back a 0
	xchg	(%ecx), %eax
	ret
   